module SimplicialComplex
  class Complex
    def initialize
      @simplices = Array.new
    end
    
    # Adds a simplex to the complex
    def add_simplex(simplex)
      (0..simplex.dim).each do |d|
        simplex.faces(d).each do |face|
          @simplices << face unless @simplices.include?(face)
        end
      end
    end
    
    # Removes a simplex from the complex
    def remove_simplex(simplex)
      @simplices.delete(simplex)
    end
    
    # Computes the dimension of the complex
    def dim
      @simplices.map {|simplex| simplex.dim}.max
    end
    
    # Computes the simplices of certain dimension
    def simplices(dim)
      simplices = Array.new
      @simplices.each do |simplex|
        simplices << simplex if simplex.dim == dim
      end
      simplices
    end
    
    
    # Outputs the vertices
    def vertices
      simplices(0).map {|simplex| simplex.vertices[0]}
    end
    
    # Outputs the star of a vertex
    def star(vertex)
      
    end
    
    # Computes the dim-Betti of the complex
    def betti(dim)
      
    end
    
    def to_json(*args)
      {dim: dim, simplices: @simplices}.to_json(*args)
    end
  end
end
