# Concrete class for a Simplex
module SimplicialComplex
  class Simplex
    attr_reader :dim, :vertices
    
    # Constructor method
    def initialize(dim, vertices = nil)
      @dim      = dim
      @vertices = vertices || Array.new(@dim + 1, Vertex.new(nil)) 
    end
    
    def face?(other)
      @vertices.to_set <= other.vertices.to_set
    end
    
    def ==(other)
      @vertices.to_set == other.vertices.to_set
    end
    
    # Computes the faces of dimension dim
    def faces(dim = @dim -1)
      faces = Array.new
      
      if dim < 0 || dim > @dim
        puts 'Faces of this dimension do not exist.'
        
      elsif dim == @dim
        faces << self
        
      else
        @vertices.combination(dim+1) do |combination|
        faces << Simplex.new(dim, combination)
        end
    end
      faces
    end

    def to_json(*args)
      {dim: @dim, vertices: @vertices}.to_json(*args)
    end
  end
end
